package com.agilecontrol.nea.core.control.ejb.command;

import com.agilecontrol.nea.core.control.ejb.Command;
import com.agilecontrol.nea.core.control.event.DefaultWebEvent;
import com.agilecontrol.nea.core.control.event.NDSEventException;
import com.agilecontrol.nea.core.control.util.ValueHolder;
import com.agilecontrol.nea.core.control.web.AttachmentManager;
import com.agilecontrol.nea.core.control.web.WebUtils;
import com.agilecontrol.nea.core.query.QueryEngine;
import com.agilecontrol.nea.core.schema.Column;
import com.agilecontrol.nea.core.schema.Table;
import com.agilecontrol.nea.core.schema.TableManager;
import com.agilecontrol.nea.core.security.User;
import com.agilecontrol.nea.util.Attachment;
import com.agilecontrol.nea.util.NDSException;
import com.agilecontrol.nea.util.Tools;
import com.agilecontrol.nea.util.Validator;
import java.rmi.RemoteException;
import java.util.Vector;

public class DeleteAttachments extends Command {

   public ValueHolder execute(DefaultWebEvent event) throws RemoteException, NDSException {
      User usr = this.helper.getOperator(event);
      this.helper.checkDirectoryWritePermission(event, usr);
      ValueHolder v = new ValueHolder();
      TableManager manager = TableManager.getInstance();
      Table table = manager.findTable(event.getParameterValue("table", true));
      Column col = manager.getColumn(Tools.getInt(event.getParameterValue("column", true), -1));
      String sql = "update " + table.getRealTableName() + " set " + col.getName() + "=null";
      if(table.getColumn("modifierid") != null) {
         sql = sql + ", modifierid=" + this.helper.getOperator(event).getId().intValue();
      }

      if(table.getColumn("modifieddate") != null) {
         sql = sql + ", modifieddate=sysdate";
      }

      sql = sql + " where id=" + event.getParameterValue("objectid", true);
      QueryEngine engine = QueryEngine.getInstance();
      Vector sqls = new Vector();
      sqls.addElement(sql);

      try {
         engine.doUpdate(sqls);
      } catch (Exception var19) {
         throw new NDSEventException(var19.getMessage());
      }

      AttachmentManager attm = (AttachmentManager)WebUtils.getServletContextManager().getActor("nea.web.AttachmentManager");
      String fileURL = (String)event.getParameterValue("file");
      Attachment att = null;
      if(Validator.isNotNull(fileURL) && fileURL.startsWith("/servlets/binserv/Attach?")) {
         String t = null;

         try {
            t = AttachmentManager.findParamValue(fileURL, "t");
         } catch (Throwable var18) {
            this.logger.error("Fail to parse t from url:" + fileURL + ":" + var18.getMessage());
         }

         if(Validator.isNotNull(t)) {
            long time = Tools.getLong(t, -1L);
            if(time > 0L) {
               String attachParent = attm.getTimeFolderParent(event.getContext().getUserWeb(), table, col, time);
               String attachDir = String.valueOf(time);
               att = attm.getAttachmentInfo(attachParent, attachDir, -1);
            }
         }
      }

      if(att == null) {
         att = attm.getAttachmentInfo(usr.getClientDomain() + "/" + AttachmentManager.getSchemaPath(event.getContext().getUserWeb().getDataSource()) + table.getRealTableName() + "/" + col.getName(), "" + event.getParameterValue("objectid", true), -1);
      }

      if(att != null) {
         attm.deleteAttachment(att);
      }

      v.put("next-screen", "/nea/core/objext/upload.jsp?table=" + event.getParameterValue("table") + "&column=" + event.getParameterValue("column") + "&objectid=" + event.getParameterValue("objectid") + "&input=" + event.getParameterValue("input"));
      v.put("message", "@clear-additional-links@");
      v.put("url", "");
      return v;
   }
}
